package com.yizhi.message.application.feign.remote;


import com.yizhi.message.application.vo.MessageVo;
import com.yizhi.message.application.vo.domain.MessageRemindVo;
import com.yizhi.message.application.vo.domain.MessageVisibleRangeVo;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

@FeignClient(name = "newMessage", contextId = "RemoteMessageClient")
public interface RemoteMessageClient {
    /**
     * 业务那边需要系统消息列表
     * (应用场景)1：学习计划、2：考试、3：调研、4、投票5：报名、6：作业、7：签到、8：项目、9：直播、10：积分
     *
     * @param relationType
     * @return
     */
    @PostMapping("/remote/message/getList")
    @ApiOperation(value = "单条消息查询", response = MessageVo.class)
    public List<MessageVo> getListByRelationType(@ApiParam("relationType 必传") @RequestParam("relationType") Integer relationType,
                                                 @ApiParam("siteId 必传") @RequestParam("siteId") Long siteId);

    @PostMapping("/remote/message/getOne")
    @ApiOperation(value = "", response = MessageVo.class)
    public MessageVo getOne(@ApiParam("id") @RequestParam("id") Long id);

    @GetMapping("/remote/message/getAuthorize")
    public List<MessageVisibleRangeVo> getAuthorize(@ApiParam("id 必传") @RequestParam("id") Long id);

    @GetMapping("/remote/message/getMessage")
    public MessageRemindVo getMessageRemind(@ApiParam("id 必传") @RequestParam("id") Long id);

}
