package com.yizhi.message.application.util;


import com.yizhi.message.application.enums.TimeType;
import com.yizhi.util.application.date.DateUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import java.util.Date;

/**
 * 根据时间发生时间和提前发送消息的类型，计算消息确切的发送时间
 *
 * @author yinyuyan
 */

public class DateConvertor {
    private static final Logger logger = LoggerFactory.getLogger(DateConvertor.class);

    private DateConvertor() {}
    public static Date calSendTime(Date current, Integer aheadType) {
        if (TimeType.FMIN.getCode().equals(aheadType)) {
            return DateUtil.add(current, 12, -5);
        } else if (TimeType.TMIN.getCode().equals(aheadType)) {
            return DateUtil.add(current, 12, -10);
        } else if (TimeType.THMIN.getCode().equals(aheadType)) {
            return DateUtil.add(current, 12, -30);
        } else if (TimeType.OHOUR.getCode().equals(aheadType)) {
            return DateUtil.add(current, 10, -1);
        } else if (TimeType.THOUR.getCode().equals(aheadType)) {
            return DateUtil.add(current, 10, -2);
        } else if (TimeType.ODAY.getCode().equals(aheadType)) {
            return DateUtil.add(current, 5, -1);
        } else if (TimeType.TDAY.getCode().equals(aheadType)) {
            return DateUtil.add(current, 5, -2);
        } else {
            return current;
        }
    }

}
