package com.yizhi.message.application.controller.jobHandle;


import com.yizhi.message.application.controller.util.BuildJob;
import com.yizhi.message.application.service.MessageRemindService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Date;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author hutao123
 * @since 2019-09-09
 */
@RestController
@Api(tags = "消息涉及job接口")
@RequestMapping("/remote/messageRemind")
public class RemoteJobHandleComtroller {

    @Autowired
    private MessageRemindService messageRemindService;
    @Autowired
    private BuildJob buildJob;
    private Logger logger = LoggerFactory.getLogger(RemoteJobHandleComtroller.class);

    /**
     * 定时任务执行实际的处理逻辑类
     * 定时任务业务逻辑处理
     *
     * @param
     * @return
     */
    @GetMapping("/messageHandle")
    @ApiOperation(value = "定时发送消息", response = String.class)
    public void sendMessageHandle() {
        logger.info("我今天就看有没有调用！！！");
        try {
            logger.info("开始处理定时任务");

            messageRemindService.sendMessageHandle();

        } catch (Exception e) {
            e.printStackTrace();
            logger.info("定时任务处理异常");
        }
    }

    @GetMapping("/buildJob")
    @ApiOperation(value = "构建一个job任务，默认每五分钟处理，也可指定cron表达式", response = String.class)
    public void buildJob(@RequestParam(value = "hanldeTime",required = false)Date hanldeTime ) throws Exception {
        if (hanldeTime == null){
            buildJob.buildJobDefault("消息处理，默认每五分钟处理一次");
        }else {
            buildJob.buildJob(new Date().toString(),hanldeTime);
        }
    }


}

