package com.yizhi.message.application.controller.remote;


import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.yizhi.message.application.constans.Constans;
import com.yizhi.message.application.domain.MessageAccount;
import com.yizhi.message.application.service.MessageAccountService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.CollectionUtils;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * <p>
 * 前端控制器 用户消息记录表
 * </p>
 *
 * @author hutao123
 * @since 2019-09-09
 */
@RestController
@Api(tags = "用户消息接口，后端内部调用接口，不给前端用")
@RequestMapping("/remote/manage/messageAccount")
public class RemoteMessageAccountComtroller {
    @Autowired
    private MessageAccountService messageAccountService;

    /**
     * 用于触发事件，直接发送消息
     *
     * @return
     */
    @GetMapping("/batchSave")
    @ApiOperation(value = "用于触发事件，直接发送消息", response = Integer.class)
    public Boolean save(@RequestBody List<MessageAccount> messageAccounts) {

        if (!CollectionUtils.isEmpty(messageAccounts)) {
            return messageAccountService.insertBatch(messageAccounts);
        }
        return false;
    }

    @GetMapping("/getList")
    @ApiOperation(value = "获取列表", response = Integer.class)
    public List<MessageAccount> getList(@RequestParam("taskType") Integer taskType, @RequestParam("taskId") Long taskId) {
        EntityWrapper wrapper = new EntityWrapper();
        wrapper.eq("deleted", Constans.NOT_DELETED);
        wrapper.eq("relation_id", taskId);
        wrapper.eq("relation_type", taskType);
        wrapper.setSqlSelect("account_id");
        return messageAccountService.selectList(wrapper);
    }
    @GetMapping("/getOne")
    @ApiOperation(value = "获取单条消息", response = Integer.class)
    public MessageAccount getOne(@RequestParam("accountId") Long accountId, @RequestParam("taskType") Integer taskType, @RequestParam("taskId") Long taskId) {
        EntityWrapper wrapper = new EntityWrapper();
        wrapper.eq("deleted", Constans.NOT_DELETED);
        wrapper.eq("relation_id", taskId);
        wrapper.eq("relation_type", taskType);
        wrapper.eq("account_id",accountId);
        wrapper.setSqlSelect("account_id");
        return messageAccountService.selectOne(wrapper);
    }

}

