package com.yizhi.message.application.controller.remote;


import com.baomidou.mybatisplus.mapper.EntityWrapper;
import com.yizhi.message.application.domain.MessageAccount;
import com.yizhi.message.application.domain.MessageRemind;
import com.yizhi.message.application.domain.MessageVisibleRange;
import com.yizhi.message.application.service.MessageAccountService;
import com.yizhi.message.application.service.MessageRemindService;
import com.yizhi.message.application.service.MessageService;
import com.yizhi.message.application.service.MessageVisibleRangeService;
import com.yizhi.message.application.vo.MessageVo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * <p>
 * 消息 前端控制器 消息主体表
 * </p>
 *
 * @author hutao123
 * @since 2019-09-09
 */
@RestController
@Api(tags = "主体消息接口，后端内部调用接口，不给前端用")
@RequestMapping("/remote/message")
public class RemoteMessageComtroller {

    @Autowired
    private MessageService messageService;

    @Autowired
    private MessageVisibleRangeService messageVisibleRangeService;

    @Autowired
    private MessageAccountService messageAccountService;

    @Autowired
    private MessageRemindService messageRemindService;

    /**
     * 业务那边需要系统消息列表
     * (应用场景)1：学习计划、2：考试、3：调研、4、投票5：报名、6：作业、7：签到、8：项目、9：直播、10：积分
     *
     * @param relationType
     * @return
     */
    @PostMapping("/getList")
    @ApiOperation(value = "业务新增时，模板消息列表查询", response = MessageVo.class)
    public List<MessageVo> getListByRelationType(@ApiParam("relationType 必传")
                                                 @RequestParam("relationType") Integer relationType) {

        return messageService.getListByRelationType(relationType);
    }

    /**
     * 业务那边需要系统消息列表
     * (应用场景)1：学习计划、2：考试、3：调研、4、投票5：报名、6：作业、7：签到、8：项目、9：直播、10：积分
     *
     * @param id 消息id
     * @return
     */
    @PostMapping("/getOne")
    @ApiOperation(value = "", response = MessageVo.class)
    public MessageVo getOne(@ApiParam("id 必传") @RequestParam("id") Long id) {
        return messageService.get(id);
    }

    @GetMapping("/getAuthorize")
    public List<MessageVisibleRange> getAuthorize(@ApiParam("id 必传") @RequestParam("id") Long id) {
        MessageVisibleRange range = new MessageVisibleRange();
        range.setMessageId(id);
        range.setDeleted(0);
        EntityWrapper<MessageVisibleRange> wrapper = new EntityWrapper<MessageVisibleRange>(range);
        List<MessageVisibleRange> list = messageVisibleRangeService.selectList(wrapper);
        return list;
    }

    @GetMapping("/getMessage")
    public MessageRemind getMessageRemind(@ApiParam("id 必传") @RequestParam("id") Long id) {
        MessageAccount messageAccount = messageAccountService.selectById(id);
        MessageRemind messageRemind = null;
        if (messageAccount != null) {
            messageRemind = messageRemindService.selectById(messageAccount.getMessageRemindId());
        }
        return messageRemind;
    }
}

